#include <math.h>
double dlgama(double arg) {
/*   *DECK DLGAMA
      DOUBLE PRECISION FUNCTION DLGAMA (ARG)
C
C     THIS ROUTINE FOR COMPUTING DLGAMA IS BASED ON THE ALGOL ROUTINE
C     IN ACM ALGORITHM NUMBER 291.  THE SIGNIFICANT CHANGES ARE THE
C     TRUNCATION OF THE ARGUMENT TO THE RANGE 1.E-35 THRU 1.E+30,
C     TAKING THE LOG OF LOCAL VARIABLE *F* EVEN WHEN THE ARGUMENT
C     IS GREATER THAN OR EQUAL TO 7, AND HANDLING ARGUMENT VALUES
C     LARGER THAN 1.E10 AS IN THE SSP ROUTINE TO AVOID EXPONENT
C     OVERFLOW.
   */
    double alng,f,z,x;
    x=arg;
    if (x>=1e10) { //     **CHECK MAGNITUDE OF ARGUMENT
        x=(x<1.e30 ? x : 1.e30); //     **AVOID LARGISH ARGUMENT
        alng=x*(log(x)-1.);
        return(alng);
    }
    else {
        x=(x<1.e-35 ? 1.e-35 : x); //  **AVOID SMALLISH ARGUMENT
        //           **ALGORITHM 291 STARTS HERE
        for (f=1; x<=7; x++) f*=x;
        f=-log(f);
        z=1./x/x;
        alng=f+(x-0.5)*log(x)-x+.918938533204673+
                  (((-.000595238095238*z+.000793650793651)*z-.002777777777778)*z+.083333333333333)/x;
    }
    return(alng);
}
