#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "modelc.h"
#include "status.h"
void dotest(FILE *F) {
    int ii=0,mgm=1,ndf,ier,i,inum,idem,j,*isv,iflg=0,iptr=0,isrt=4,icod,k,lo,itmp;
    double c=0,chisq,prob,**aic,tmp,sumn=0; char *ctmp; FILE *f;
	int getcmd(FILE *x); double cdtr(double chisq, int ndf, int *ier); 
	void srverror(char *x); void srvwarn(char *x);
    //          MGM=MODEL NUMBER OF MOST-GENERAL-MODEL
    if ((isv=malloc((maxmod+1)*sizeof(int)))==NULL)  srverror("allocating memory for isv");
    if ((aic=malloc((maxmod+1)*sizeof(double*)))==NULL) srverror("allocating memory for aic");
    for (i=0; i<=maxmod; i++)
        if ((aic[i]=malloc(5*sizeof(double)))==NULL) srverror("allocating memory for aic[]");
    for (i=1; i<=ncoht; i++) sumn+=n[i];  //    sum cohorts for corrected AIC
    for (i=1; i<=lstwrd; i++) {
        if (stricmp(words[i],"AICSAVE")==0) iflg=1;
        if (stricmp(words[i],"SORTBY")==0) iptr=1;
        if (stricmp(words[i],"C")==0) c=atof(words[i+2]);
    }
    if (iptr>0 && iptr<lstwrd) {
        if (stricmp(words[iptr+1],"AIC")==0) isrt=1;
        if (stricmp(words[iptr+1],"AICC")==0) isrt=2;
        if (stricmp(words[iptr+1],"QAIC")==0) isrt=3;
        if (stricmp(words[iptr+1],"QAICC")==0) isrt=4;
    }
    if (iflg==1) { //             READ AIC'S FROM PREV RUN MODELS
        if ((f=fopen(words[5],"r"))==NULL) srvwarn("old AIC file not found.");
		else {
			i=modnum;
			for (j=1; j<=maxmod; j++) {
				icod=fscanf(f,"%s %f %f %d %d %f %f %d",modsav[i].modnam,aic[i][1],modsav[i].xllval,modsav[i].ndfsav,modsav[i].nestsv,modsav[i].modgof,modsav[i].gofg,modsav[i].gofdf);
				for (ii=0, k=1; k<=modnum; k++) if (strcmp(modsav[i].modnam,modsav[k].modnam)==0) ii=k;
				if (ii>0) i--;
			}
			fclose(f);
		}
        ii=1; //  OPEN AIC FILE FOR OUTPUT 
        if ((f=fopen(words[5],"w"))==NULL) srvwarn("can't open old AIC file for output.");
        modnum=i-1;
    }
    getcmd(F);
    if (modnum<=1) srvwarn("Not enough PROC ESTIMATE statements to generate models for testing.");
    else {
        for (i=1; i<=modnum; i++) {
            isv[i]=i;
            aic[i][1]=-2.0*modsav[i].xllval+2.0*modsav[i].nestsv;
            aic[i][2]=aic[i][1]+2.0*modsav[i].nestsv*(modsav[i].nestsv+1)/ (double)(sumn-modsav[i].nestsv-1);
            if (modsav[i].nestsv>modsav[mgm].nestsv) mgm=i;
        }
        if (c<1.0 && modsav[mgm].gofdf!=0) c=modsav[mgm].gofg/(double)(modsav[mgm].gofdf);
        if (c<1.0)c=1;
        //                COMPUTE QUASI-AIC (AIC(*,3)) & CORRECTED QAIC (AIC(*,4))
        fprintf(G,"\nModified AIC calculations: (see 'Model Selection and Inference:\n");
        fprintf(G, " A Practical Information Theoretic Approach by K. P. Burnham\n");
        fprintf(G, " and David R. Anderson, 1998\n");
        fprintf(G,"\n  Most General Model:%s\n",modsav[mgm].modnam);
        fprintf(G,  "  n=%d c=%f\n",sumn,c);
        fprintf(G,  "  Model   K    AIC         AICc         QAIC         QAICc\n");
        for (i=1; i<=modnum; i++) {
            aic[i][3]=-2.0*modsav[i].xllval/c+2.0*modsav[i].nestsv;
            aic[i][4]=aic[i][3]+2.0*modsav[i].nestsv*(modsav[i].nestsv+1)/(double)(sumn-modsav[i].nestsv-1);
            fprintf(G,"%4d %7d %12.6f %12.6f %12.6f %12.6f %12.6f\n",i,modsav[i].nestsv,aic[i][1],aic[i][2],aic[i][3],aic[i][4]);
        }
        //                SORT MODELS BY AIC
        for (i=1; i<modnum; i++) {
            for (lo=i, j=i+1; j<=modnum; j++) if (aic[j][isrt]<aic[lo][isrt]) lo=j;
            itmp=isv[i]; isv[i]=isv[lo]; isv[lo]=itmp;
			ctmp=modsav[i].modnam; modsav[i].modnam=modsav[lo].modnam; modsav[lo].modnam=ctmp;
          //  strcpy(ctmp,modsav[i].modnam); strcpy(modsav[i].modnam,modsav[lo].modnam); strcpy(modsav[lo].modnam,ctmp);
            tmp=modsav[i].xllval; modsav[i].xllval=modsav[lo].xllval; modsav[lo].xllval=tmp;
            for (j=1; j<=4; j++) {
                tmp=aic[i][j]; aic[i][j]=aic[lo][j]; aic[lo][j]=tmp;
            }
            itmp=modsav[i].ndfsav; modsav[i].ndfsav=modsav[lo].ndfsav; modsav[lo].ndfsav=itmp;
            itmp=modsav[i].nestsv; modsav[i].nestsv=modsav[lo].nestsv; modsav[lo].nestsv=itmp;
            tmp=modsav[i].modgof; modsav[i].modgof=modsav[lo].modgof; modsav[lo].modgof=tmp;
            tmp=modsav[i].gofg; modsav[i].gofg=modsav[lo].gofg; modsav[lo].gofg=tmp;
            itmp=modsav[i].gofdf; modsav[i].gofdf=modsav[lo].gofdf; modsav[lo].gofdf=itmp;
        }
        fprintf(G,"\n               Log-\n");
        fprintf(G,"  Submodel  likelihood    NDF    AIC       G-O-F    AICC      QAIC      QAICC\n");
        fprintf(G," ---------  ----------    --- ---------    ------  -------   -------   -------\n");
        for (i=1; i<=modnum; i++) {
            if (ii>0) fprintf(f,"%d %s %10.4f %d %11.5f %6.4f %9.4f %9.4f %9.4f",
                    modsav[i].modnam,aic[i][1],modsav[i].xllval,modsav[i].ndfsav,modsav[i].nestsv,modsav[i].modgof,modsav[i].gofg,modsav[i].gofdf);
            fprintf(G,"%d %-10s %10.4f %5d %11.5f %6.4f %9.4f %9.4f %9.4f\n",
                   isv[i],modsav[i].modnam,modsav[i].xllval,modsav[i].ndfsav,aic[i][1],modsav[i].modgof,aic[i][2],aic[i][3],aic[i][4]);
		}	
        if (ii>0) 
			fclose(f);
        fprintf(G,"\nLikelihood Ratio Tests Between Models\n");
        fprintf(G," General              Reduced                           Degrees   Pr(Larger\n");
        fprintf(G," Submodel             Submodel              Chi-square  Freedom  Chi-square)\n");
        fprintf(G,"----------           ----------             ----------  -------  -----------\n");
        for (i=1; i<modnum; i++)
            for (j=i+1; j<=modnum; j++) {
                if (modsav[i].ndfsav>modsav[j].ndfsav) { inum=i; idem=j; }
                if (modsav[i].ndfsav<modsav[j].ndfsav) { inum=j; idem=i;}
                if (modsav[i].ndfsav!=modsav[j].ndfsav) {
                    chisq=-2.0*(modsav[inum].xllval-modsav[idem].xllval);
                    ndf=modsav[inum].ndfsav-modsav[idem].ndfsav;
                    if (chisq>0. && ndf>0) {
                        prob=cdtr(chisq,ndf,&ier);
                        if (ier!=0) srvwarn("error with chi-square probability.");
                        prob=1.0-prob;
                    }
                    else { prob=1.0; chisq=0.0; }
                    fprintf(G," %10s%22s %21.3f%7d%13.4f\n",modsav[idem].modnam,modsav[inum].modnam,chisq,ndf,prob);
                }
            }
    }
    modnum=0; srvwarn("Sequence of models reinitialized to zero.");
    for (i=0; i<=maxmod; i++) free(aic[i]); free(aic); free(isv);
}
