#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <malloc.h>
#include "status.h"
#include "modelc.h"
void estmat(int intry, FILE *F) {

    double *h,*g,*w,*ppar,*expect,*observ,*htmp,
              chisq,chisqp,chisqi,gcontr,contrb,prob,xll;
	double tmppar,tmpss;
    int ndf,ndfp,ndfi,itran1;
    char note[16];
    int ijobop=0,ier,i,j,k,l,m,ierinv=0,tmem1=0,mpar;
	int progrs,nfixed;

    void getpim(FILE *F); double ss(int i, int icht, int icls);    
    void srverror(char *x); void srvwarn(char *x);
	double cdtr(double chisq, int ndf, int *ier); 
	double dlgama(double x); double dabs(double x);
    double est(int nest, double *ppar);
    int matinv(double *h, double *g, int ijobiv, int n); 
	double cspool(double *observ, double *expect, int *ndfi, int nc);
	int getcmd(FILE *F); void consrt(int *i, FILE *F); void inital(FILE *F, double *ppar); 
	void varcov(double *g, double *h, double *ppar, int itran1);
	void srverror(char *s);
	//double dabs(double x);
	int optmiz(int nest, int nsig, int maxfn, int ijobop, double *ppar, double *h, double *g, double *xll, double *w);
    
    if (intry<2) {
        fprintf(G,"INPUT--%s\n",lststr); 
        modsav[++modnum].xllval=-1.0e20; modsav[modnum].ndfsav=0; modsav[modnum].modgof=0;
        sprintf(modsav[modnum].modnam,"SUBMODEL%d",modnum);
        nsig=9; maxfn=1000; notran=FALSE; sintrn=TRUE; novar=FALSE; nobinc=FALSE; nfcalls=0;
        progrs=0; itrans=2; idmat=1; ncols=0; ncons=0; nfixed=2; nfcall=0;
        fix[1]=0; fix[2]=1; fix[3]=-2; nest=npar; ipstar=0;
        // TAKE CARE OF INFORMATION ON PROC CARD.
        for (i=3; i<=lstwrd; i++) {
            if (stricmp(words[i],"NSIG")==0) nsig=atoi(words[i+2]);
            if (stricmp(words[i],"MAXFN")==0) maxfn=atoi(words[i+2]);
            if (stricmp(words[i],"PSTAR")==0) ipstar=atoi(words[i+2]);
            if (stricmp(words[i],"PROGRESS")==0) progrs=atoi(words[i+2]);
            if (stricmp(words[i],"NAME")==0) strcpy(modsav[modnum].modnam,words[i+2]);
            if (stricmp(words[i],"VARCOV")==0) if (strnicmp(words[i],"HESS",4)==0) vcopt=2;
            if (strnicmp(words[i],"NOV",3)==0) novar=TRUE;
            if (strnicmp(words[i],"NOB",3)==0) nobinc=TRUE;
            if (strnicmp(words[i],"SCALE",5)==0) scaleopt=TRUE;
            if (strnicmp(words[i],"DEBUG",5)==0) debug=100;
            if (strnicmp(words[i],"TRANS",5)==0) {
                if ( strnicmp(words[i+2],"ABS",3)==0) { sintrn=FALSE; itrans=3; }
                if (strnicmp(words[i+2],"NO",2)==0) { notran=TRUE; itrans=0; }
                if (strnicmp(words[i+2],"LOG",3)==0) itrans=2;
                if (strnicmp(words[i+2],"SIN",3)==0) itrans=1;
                }
         }
        // INITIAL PARAMETERS AND THEIR BOUNDS
        ncons=0; nfix=0; nest=npar;
        i=getcmd(F);fprintf(G,"INPUT--%s\n",lststr); printf("malloc in estmat: nest=%d npar=%d\n",nest,npar); 
        while (strnicmp(words[1],"PROC",4)!=0) { printf(">>>>%s\n",words[1]);
            if (strnicmp(words[1],"PIM",3)==0) { 
                indent=3; getpim(F); nest=ncols; mpar=nrows; if (ncols>nrows) mpar=ncols;
		//              ALLOCATE MEMORY FOR s,g,h,ppar,w
                if ((par=malloc((mpar+1)*sizeof(double)))==NULL) srverror("allocating memory for par"); 
                if ((ppar=malloc((mpar+1)*sizeof(double)))==NULL) srverror("allocating memory for ppar"); 
                if ((g=malloc((mpar+1)*sizeof(double)))==NULL) srverror("allocating memory for g"); 
                if ((h=malloc((1+(mpar+1)*(mpar+2)/2)*sizeof(double)))==NULL) srverror("allocating memory for h"); 
                if ((htmp=malloc((1+(mpar+1)*(mpar+2)/2)*sizeof(double)))==NULL) srverror("allocating memory for htmp"); 
                if ((w=malloc(3*(mpar+1)*sizeof(double)))==NULL) srverror("allocating memory for w"); 
                tmem+=9*((mpar+1)*sizeof(double))+(mpar+1)*(mpar+2)/2*sizeof(double);
                for (i=0; i<=mpar; i++) par[i]=ppar[i]=.5;
            }
            if (strnicmp(words[1],"FIXED",6)==0) consrt(&nfixed,F);
            if (strnicmp(words[1],"INIT",4)==0) inital(F,ppar);
            if (strnicmp(words[1],"CONSTRAINT",10)==0) {
				fprintf(G,"CONSTRAINTS not implimented in this version.  To constrain a parm, set pim to negative\n");
				fprintf(G,"  index (-j), then set fixed constant to value. [note: the first 2 fixed constants\n");
				fprintf(G,"  fix(0), and fix(1) are predefined to 0 and 1. So, the first fixed constant read\n");
                fprintf(G,"  from the list will correspond to a pim value of -2.]\n");
			}
            if (indent==1) srvwarn("Unrecognized command after PROC ESTIMATE.");
            getcmd(F); fprintf(G,"INPUT--%s\n",lststr); 
        }
    }
    itran1=itrans; //printf("nest=%d npar=%d,itrans=%d intry=%d\n",nest,npar,itrans,intry);
    if (intry<3) {
        fprintf(G,"\n ===== FIXED VALUES:(NEGATIVE PIMS)\n");
		for (i=0; i<nfixed; i++) fprintf(G,"%5d %14.8f\n",-i,fix[i+1]);
		indent=1; 
        fprintf(G,"\n      Number of parameters in model  = %d\n",nrows);
        fprintf(G,"                           Lower    Upper\n");
        fprintf(G,"   I   Parameter   S(I)    Bound    Bound  Label\n");
        fprintf(G,"  ---  ---------  ------   -----    -----  --------------------\n");
        for (i=1; i<=nest; i++) par[i]=ppar[i];
		fprintf(G,"\n       ==== INITIAL VALUES:(TRANSFORM=%d)\n",itrans);
        //  LOOP TO PRINT INITIAL CONDITIONS
        for (i=1; i<=nrows; i++) {
			tmppar=par[i];
			if (itrans==1) ppar[i]=asin((tmppar-0.5)*2.0);
			else if (itrans==2)
				if (tmppar>0.) ppar[i]=log(tmppar/(1.0-tmppar));
			par[i]=ppar[i];
			tmpss=ss(i,1,1);
			fprintf(G,"%5d%20s %14.8f %14.8f %19.8f\n",i,slabel[i],tmppar,ppar[i],tmpss);
		}
		for (i=nrows+1; i<=ncols; i++) {
		    par[i]=ppar[i];
			fprintf(G,"%5d                     %14.8f\n",i,ppar[i]);
		}
        // CHECK THAT THE CELL PROBABILITIES ADD TO UNITY
        xll=est(nest,ppar);
        for (j=1; j<=ncoht; j++) {
            for (xll=0.,k=1; k<=nclass[j]; k++) 
				xll+=p[j][k];
            if (dabs(1.-xll)>0.0001) {
                fprintf(G,"\n *** WARNING : Cell probabilities do not sm to 1.0 for at least one cohort.\n");
                fprintf(G,"     Cohort %d does not sum to 1.0.(sum=%e)\n",j,xll);
                fprintf(G,"\n *** WARNING : Results will be incorrect.\n");
                fprintf(G,"        P ="); for (k=1; k<nclass[j]; k++) fprintf(G," %15.8e",p[j][k]); 
            }
        }
        if (nest>0) ieropt=optmiz(nest,nsig,maxfn,ijobop,ppar,h,g,&xll,w);
        else {
            ieropt=0; w[3]=14; w[2]=0;
        }
		
        for (i=1; i<=nest; i++) par[i]=ppar[i];
        if (detail) {
            fprintf(G,"\n     Final function value %14.8f (Error Return = %d)\n",xll,ieropt);
            fprintf(G,"     Number of significant digits   %5d\n",(int)w[3]);
            fprintf(G,"     Number of function evaluations %5d\n",(int)w[2]);
        }
        if (ieropt!=0) {
            if (ieropt==129) 
                srvwarn("Hessian matrix was not initialized positive definite for Model");
            else if (ieropt==130) {
                srvwarn("Rounding errors became dominant before parameters estimated");
                srvwarn("to NSIG digits for Model");
                srvwarn("Check to be sure the parameters are identifiable,");
                srvwarn("but the problem may just be ill-conditioned.");
            }
            else if (ieropt==131) {
                srvwarn("Number of function evaluations exceed MAXFN limit before");
                srvwarn("parameters estimated to NSIG digits for Model");
            }
            else srverror("Unknown error message from OPMIZ subroutine."); 
        }
		varcov(g,h,ppar,itran1);
	}
		
	ndf=0; chisq=0; ndfp=0; chisqp=0; xll=-xll;
	if (idmat==11 && nrows==ncols) {
		fprintf(G,"\n               GOODNESS-OF-FIT TEST FOR MODEL %s\n",modsav[modnum].modnam);
		fprintf(G,"   Cohort  Cell   Observed  Expected  Chi-square Note\n");
		fprintf(G,"   ------  ----   --------  --------  ---------- -------------\n");
		if ((observ=malloc((mxcl1+1)*sizeof(double)))==NULL) srverror("allocating memory for observ\n"); 
		if ((expect=malloc((mxcl1+1)*sizeof(double)))==NULL) srverror("allocating memory for expect\n"); 
		tmem+=(mxcl1+1)*sizeof(double)*2;

		for (i=1; i<=ncoht; i++) {
			if (!nobinc) xll+=dlgama(n[i]+1);
			for (j=1; j<=nclass[i]; j++) {
				if (!nobinc) xll-=dlgama(obs[i][j]+1);
				expect[j]=n[i]*p[i][j];  observ[j]=obs[i][j];
				if (expect[j]>pow(10,-nsig) && observ[j]>0) gcontr=2.*log(observ[j]/expect[j])*observ[j];
				else gcontr=0;
				if (expect[j]>pow(10,-nsig)) contrb=(observ[j]-expect[j])*(observ[j]-expect[j])/expect[j];
				else contrb=0;
				if (detail) {
					if (p[i][j]<0. || p[i][j]>1.) strcpy(note,"NOT 0<P<1");
					else strcpy(note," ");
					fprintf(G,"   %4d    %3d%12.3f %9.3f %10.3f   %s %s\n",i,j,obs[i][j],expect[j],contrb,caphis[i][j],note);
				}
				chisq+=gcontr;
			}
			ndf+=nclass[i]-1;  ndfi=nclass[i]-1;
			chisqi=cspool(observ,expect,&ndfi,nclass[i]);
			chisqp+=chisqi; ndfp+=ndfi;
			if (detail) {
				prob=1.-cdtr(chisqi,ndfi,&ier);
				fprintf(G,"   %4d Cohort N=%10.3f df=%3d   %10.3f   P = %6.4f\n",i,n[i],ndfi,chisqi,prob);
			}
		}
		free(observ); 
		free(expect); 
		tmem-=(mxcl1+1)*sizeof(double)*2;
		if (detail) fprintf(G,"   ------------------------------------------------------------\n");
		ndf-=nest; modsav[modnum].nestsv=nest; modsav[modnum].ndfsav=ndf;
		prob=cdtr(chisq,ndf,&ier);
		if (ier!=0) fprintf(G,"\n *** WARNING: ERROR with chi-square probability.\n"); 
		prob=1.-prob; modsav[modnum].modgof=prob; ndfp-=nest;
		fprintf(G,"@@%5d%5d%5d%4d %13.6g%4d %13.6g%13.6g%13.6g\n",modnum,ieropt,ierinv,ndf,chisq,ndfp,chisqp,xll,-2.*xll+2*nest);
		//    print aic,log-lik,model-name for grep-ing
		fprintf(G,"@=%13.6g %13.6g %4d %s\n",-2.*xll+2*nest,xll,nest,modsav[modnum].modnam);
		if (detail) {
			fprintf(G,"   G Total (Degrees of freedom = %4d) %11.3g\n",ndf,chisq);
			fprintf(G,"   Pr(Larger Chi-square) = %6.4f)\n",prob);
		}
		modsav[modnum].gofg=chisq; modsav[modnum].gofdf=ndf;
		if (ndfp>0) {
			prob=cdtr(chisqp,ndfp,&ier);
			if (ier!=0) printf("\n *** WARNING: ERROR with chi-square probability.\n");
			prob=1.-prob;
			if (detail) {
				fprintf(G,"   With pooling, Degrees of freedom = %4d  Pearson Chi-square = %11.3f\n",ndfp,chisqp);
				fprintf(G,"   Pr(Larger Chi-square) = %6.4f)\n",prob);
			}
		}
	}
    if (detail) 
        fprintf(G,"\n   Log-likelihood = %14.8f    Akaike Information Criterion = %14.8f\n",xll,-2.*xll+2*nest);
        modsav[modnum].xllval=xll;

//	free(par);
/*	free(w); free(ppar); free(g); free(h); 
	for (i=0; i<=nrows; i++) { free(desmat[i]); }
	free(desmat); free(par);
	for (i=0; i<2; i++) {
		free(jsrv[i]); free(jp[i]); free(jdlta[i]);
	}
	free(jsrv);	free(jp); free(jpi); free(jdlta);
*/
return;
}
