#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "modelc.h"
double est(int np, double *ppar) {
/* estunsex.c
        DATE WRITTEN: 4/16/2003
        PROGRAMMER  : J. HINES
        PURPOSE     : COMPUTE CELL PROBABILITIES FOR
                       JOLLY-with unsexed captures MODEL
*/
    int i,j,k,fcap,lcap,iage,sex,fcapknown,smgt1flg=0; 
    double xll=0.,eps,penlty=0,sm,p1,p2,tsrv,tp,tmpp1,tmpp2,tmpd1;
    double ss(int i, int icoht, int icls);
    double dmax(double x, double y);
    for (i=1; i<=nest; i++) par[i]=ppar[i];
    eps=pow((double) 10.,(double) -nsig);
    if (nfcalls<2) printf("nsig=%d\n",nsig);
    if (++nfcalls<=debug && debug>0) {
        printf("nyrs,ncoht,piopt,dltaopt=%d,%d,%d,%d\n",nyrs,ncoht,piopt,dltaopt);
        printf("pi=\n");
        for(i=0;i<nyrs;i++)printf(" %f",ss(jpi[i],1,1));
        printf("\n");
        fprintf(G,"itrans=%d\nicov:\n",itrans);
        for (i=1; i<=ncoht; i++) 
            for (j=1; j<nclass[i]; j++) fprintf(G,"%d %d %f\n",i,j,icov[i][j][0]);
    }
    i=nyrs-1; chi[0][nyrs-1]=1; chi[1][nyrs-1]=1;
	//if (nfcalls<=debug) printf("piopt=%d dltaopt=%d nclass=%d %d %d %d\n",piopt,dltaopt,nclass[1],nclass[2],nclass[3],nclass[4]);
    for (i=1; i<=ncoht; i++) { sm=0;
        for (j=1; j<nclass[i]; j++) {
            //if (nfcalls<=debug) printf("%d %d %s: \n",i,j,caphis[i][j]);
            for (sex=0; sex<2; sex++)
                for (k=nyrs-2; k>=0; k--) {
                    tsrv=ss(jsrv[sex][k],i,j); tp=ss(jp[sex][k],1,1);
                    //if (nfcalls<debug && i==1 && j<3) 
					//	printf("tsrv(%d %d %d)= %f %d tp=%f\n",i,j,k,tsrv,jsrv[sex][k],tp);
                    chi[sex][k]=tsrv*(1-tp)*chi[sex][k+1]+1-tsrv;
                }
            //if (nfcalls<=debug) for (k=nyrs-1; k>=0; k--) printf("chi(,%d)=%f %f\n",k,chi[0][k],chi[1][k]);
            //               determine sex
            for (k=1,fcap=fcapknown=lcap=0,sex=-1; k<=nyrs; k++) 
                if (caphis[i][j][k-1]>'0') { 
                    lcap=k; if (fcap<=0) fcap=k;
                    if (caphis[i][j][k-1]=='M') { sex=0; if (fcapknown<=0) fcapknown=k; }
                    if (caphis[i][j][k-1]=='F') { sex=1; if (fcapknown<=0) fcapknown=k; }
                }
            p1=p2=1.; //if(nfcalls<=debug) printf("fcap=%d lcap=%d sex=%%d\n",fcap,lcap,sex);
            for (k=fcap+1; k<=lcap; k++,iage++) 
                if (sex<0) {      // unknown sex
                    if (dltaopt==2) { tmpp1=ss(jp[0][k-2],1,1); tmpp2=ss(jp[1][k-2],1,1); }
                    else {
                        tmpp1=ss(jp[0][k-2],1,1)*(1.-ss(jdlta[0][k-1],1,1));
                        tmpp2=ss(jp[1][k-2],1,1)*(1.-ss(jdlta[1][k-1],1,1));
                    }
                    if (caphis[i][j][k-1]=='0') { tmpp1=1.-ss(jp[0][k-2],1,1); tmpp2=1.-ss(jp[1][k-2],1,1); } 
                    p1*=ss(jsrv[0][k-2],i,j)*tmpp1; p2*=ss(jsrv[1][k-2],i,j)*tmpp2;
                    //if (nfcalls<=debug) printf("p1,p2,tmpp1,tmpp2=%16.6e %f %f %f\n",p1,p2,tmpp1,tmpp2); 
                }
                else {            // known sex   (dltaopt=1 -> delta=1 once sex is known)
                    //          (dltaopt=2 -> no deltas in prob structure)
                    tmpp1=ss(jp[sex][k-2],1,1); if (dltaopt<2) tmpd1=ss(jdlta[sex][k-1],1,1);
                    if (caphis[i][j][k-1]=='0') { tmpp1=1.-tmpp1; tmpd1=1; }
                    if (caphis[i][j][k-1]=='U') tmpd1=1.-tmpd1;
                    if ((dltaopt==1 && k>fcapknown)||dltaopt==2) tmpd1=1.;
                    p1*=ss(jsrv[sex][k-2],i,j)*tmpp1*tmpd1;
                    //if (nfcalls<=debug) printf("p1,tmpp1,tmpd1=%16.6e %f %f\n",p1,tmpp1,tmpd1); 
                }		
            if (sex<0) {  //    add chi term and pi and 1st delta term for unknown
                if (dltaopt==2) {
                    p1*=chi[0][lcap-1]*ss(jpi[fcap-1],1,1);
                    p2*=chi[1][lcap-1]*(1.-ss(jpi[fcap-1],1,1));
                }
                else {
                    p1*=chi[0][lcap-1]*ss(jpi[fcap-1],1,1)*(1.-ss(jdlta[0][fcap-1],1,1));
                    p2*=chi[1][lcap-1]*(1.-ss(jpi[fcap-1],1,1))*(1.-ss(jdlta[1][fcap-1],1,1));
                }
                //if (nfcalls<=debug) 
                //    printf("p1,p2=%16.6e %f chi=%f %f pi=%f delta=%f %f\n",
                //            p1,p2,chi[0][lcap-1],chi[1][lcap-1],
                //            ss(jpi[fcap-1],1,1),ss(jdlta[0][fcap-1],1,1),ss(jdlta[1][fcap-1],1,1)); 
            }
            else {   //    add chi term and pi and 1st delta term for known
                p1*=chi[sex][lcap-1];
                if (piopt==0) {
                    if (sex==0) p1*=ss(jpi[fcap-1],1,1); else p1*=1.-ss(jpi[fcap-1],1,1);
                }
                //if (nfcalls<=debug) printf("p1=%16.6e pi=%f\n",p1,ss(jpi[fcap-1],1,1));
                if (dltaopt<2) {
                    if (caphis[i][j][fcap-1]=='U') p1*=(1.-ss(jdlta[sex][fcap-1],1,1));  // tack on Pr(obs as ?) for 
                    else p1*=ss(jdlta[sex][fcap-1],1,1);                                 // 1st capture occasion
                }
                //if (nfcalls<=debug) printf("p1=%16.6e pi=%f dlta=%f\n",p1,ss(jpi[fcap-1],1,1),ss(jdlta[sex][fcap-1],1,1));
                p2=0.;
            }
            p[i][j]=p1+p2; sm+=p[i][j]; //if (nfcalls<=debug) printf("p(%d,%d)=%16.8e\n",i,j,p[i][j]);
        } 
        if (sm>1. && nfcalls<0) {
            printf("=====> sum(p(,))>1.0 (%f)<==== cohort:%d nclass=%d\n",sm,i,nclass[i]);
			smgt1flg=1;
            //for (j=1; j<=nclass[i]; j++) 
                //printf("%d %c%c%c%c%c%c%c%c %f\n",j,caphis[i][j][0],caphis[i][j][1],caphis[i][j][2],caphis[i][j][3],
				                            //caphis[i][j][4],caphis[i][j][5],caphis[i][j][6],caphis[i][j][7],p[i][j]);
            //exit(1);
        }
        //if (nfcalls<=debug) printf("sum(p(%d,))=%16.8f\n",i,sm);
    }
    //                 COMPUTE LOG LIKELIHOOD 
    for (xll=0., i=1; i<=ncoht; i++) {
        for (j=1,sm=0; j<nclass[i]; j++) sm+=p[i][j];
        if (dltaopt<2) p[i][nclass[i]]=1-sm;
        else for (j=1; j<=nclass[i]; j++) p[i][j]/=sm;
        for (j=1; j<=nclass[i]; j++) xll+=obs[i][j]*log(dmax(eps,p[i][j])); 
    }
    if((nfcalls&255)==1) printf("%d %f\n",nfcalls,xll);
    return(-xll);
}
