/*  gencapunsex.c - Generates capture history records.          */
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <math.h>
#include <process.h>
FILE *fopen(), *fp;
#define eps .00005

long nper, debug=0, remembersex=0, determ=1, dim;  double *nx,*pa,*sa,*dl,*tcap,*talive;

double unif(void) { return(rand()/(double)RAND_MAX); }

double unorm(double xn, double se) { 
    int i; double sumr=-6.; for (i=0; i<12; i++) sumr+=rand()/(double)RAND_MAX; 
    sumr=sumr*se+xn; if (!determ) sumr=floor(sumr+0.5);
    return(sumr); 
}

double binoml(double n,double p) /* binomial function */
{  double np,tr,b,x,bin,pp; long i,nn; double y;
    bin=0; if (determ)  return(n*p);
    if (p>0)                                      /* compute binomial directly     */
        if (n<=100) { nn=floor(n); for (i=1;i<=nn;bin+=(unif()<=p),i++); }   
        else
        { np=n*p;                                     /* normal approx */
            if (p>=.05 && p<=.95) { for (x=-6,i=1;i<=12;x+=unif(),i++); y=np*(1-p);bin=floor(sqrt(y)*x+np); }
            else {
                pp=p; if (p>.9) pp=1-p;                           /* poisson approx  */
                for ( b=-n*pp, tr=0; tr>=b; bin++) tr+=log(unif());
                if (p>.9) bin=n-bin;
              //  printf("binoml(%f, %f)=%f\n",n,p,bin);
            }
        }
    return(bin);
}

void caphis(long ch,double n,long per, int sex, int knownsex)
{ double s1, s2, nalive, ncap, Notcap, ndead, ncapKnown,ncapNotKnown,tmpdlta,
              naliveKnown,ndeadKnown,naliveNotKnown,ndeadNotKnown,Notcapalive,Notcapdead;
    long i;
    ncap=binoml(n,pa[sex*(nper)+per-1]); tcap[per-1]+=ncap;  Notcap=n-ncap;
    tmpdlta=dl[sex*nper+per-1]; if (knownsex>0 && remembersex>0) tmpdlta=1;
    ncapKnown=binoml(ncap,tmpdlta); ncapNotKnown=ncap-ncapKnown;
    if (debug) printf("ch=%ld ncap=%lf (%ld %ld %ld) p=%lf dlta=%f\n",ch,ncap,sex,nper,per,pa[sex*(nper)+per-1],dl[sex*nper+per-1]);
    if (per<nper) {
            //   captured
        naliveKnown=binoml(ncapKnown,sa[sex*(nper-1)+per-1]); talive[per]+=naliveKnown; 
        ndeadKnown=ncapKnown-naliveKnown;
        naliveNotKnown=binoml(ncapNotKnown,sa[sex*(nper-1)+per-1]); talive[per]+=naliveNotKnown;
        ndeadNotKnown=ncapNotKnown-naliveNotKnown; 
        Notcapalive=binoml(Notcap,sa[sex*(nper-1)+per-1]);
        Notcapdead=Notcap-Notcapalive; 
        i=(ch|((sex+1)*(1<<(2*nper-2*per)))); nx[i]+=ndeadKnown; 
        if(debug)printf("%d %9.4f %9.4f %9.4f %9.4f %9.4f %9.4f\n",per,naliveKnown,ndeadKnown,naliveNotKnown,ndeadNotKnown,Notcapalive,Notcapdead);
        if (naliveKnown>0) caphis(i,naliveKnown,per+1,sex, 1);
        if(debug)printf("============\n");
        i=(ch|(3*(1<<(2*nper-2*per)))); nx[i]+=ndeadNotKnown; 
        if (naliveNotKnown>0) caphis(i,naliveNotKnown,per+1,sex,knownsex);
        nx[ch]+=Notcapdead; 
        if (Notcapalive>0) caphis(ch,Notcapalive,per+1,sex,knownsex);
    }
    else { 
        i=ch|(sex+1); nx[i]+=ncapKnown; 
        i=ch|3; nx[i]+=ncapNotKnown; 
        nx[ch]+=Notcap; 
        if(debug)printf("%d %9.4f %9.4f %9.4f %9.4f %9.4f %9.4f\n",per,ncapKnown,-1.,ncapNotKnown,-1.,Notcap,-1.);
    }
}
int main(int argc, char **argv) {
    double *na,*fa,*sef, tmp; 
    char c,*cc,chcodes[4]="0MFU"; 
    long i,j,k,tst,jlyflg=0,capflg=0,mrkflg=0,sumn=0,recruit=0,klmt,kk;
    printf("usage: gencapunsex [{CAPTURE|JOLLY|MARK}][EXP][STOCHASTIC][RECRUIT={BINOMIAL|NORMAL}]\n");
    for (i=1,determ=1; i<argc; i++) 
    { if (strstr(argv[i],"JOLLY")!=0) jlyflg=1;
        if (strstr(argv[i],"CAPTURE")!=0) capflg=1;
        if (strstr(argv[i],"MARK")!=0) mrkflg=1;
        if (strstr(argv[i],"DEBUG")!=0) debug=1;
        if (strstr(argv[i],"EXP")!=0) determ=1;
        if (strstr(argv[i],"DETERM")!=0) determ=1;
        if (strstr(argv[i],"STOCHASTIC")!=0) determ=0;
        if (strstr(argv[i],"REMEMBERSEX")!=0) remembersex=1;
        if (strstr(argv[i],"RECRUIT=BINOMIAL")!=0) recruit=1;
        if (strstr(argv[i],"RECRUIT=NORMAL")!=0) recruit=2;
        printf("%s\n",argv[i]);
    }
    srand( (unsigned)time( NULL ) ); fp=fopen("gencapunsex.out","w");  printf("enter nper:"); scanf("%d",&nper); 
    dim=1<<(2*nper);
    if (determ) printf("\nExpected value data generated\n"); else printf("\nStochastic data generated\n");
    if (remembersex>0) printf("\nOnce sex is known, it stays known\n"); else printf("\nUnknown sex is independent of capture history\n");
    if (jlyflg==1) fprintf(fp,"TITLE=SIMULATED DATA\nPERIODS=%d\nFORMAT=(%dI1,I6)\n",nper,nper); 
    if (capflg==2) 
    { fprintf(fp,"title='simulated data'\ntask read captures occasions=%d x matrix\n",nper);
        fprintf(fp,"format='(a8,1x,%df1.0)'\nread input data\n",nper);
    }
        fprintf(fp,"proc title 'exp value data';\n");
        fprintf(fp,"proc model nyrs=%d;\n",nper);
    
    if ((na=malloc(2*nper*sizeof(double)))==NULL) { printf("error allocating memory for n[%d]\n",2*nper); exit(1);}
    if ((tcap=malloc(2*nper*sizeof(double)))==NULL) { printf("error allocating memory for tcap[%d]\n",2*nper); exit(1);}
    if ((talive=malloc(2*nper*sizeof(double)))==NULL) { printf("error allocating memory for talive[%d]\n",2*nper); exit(1);}
    if ((pa=malloc(2*nper*sizeof(double)))==NULL) { printf("error allocating memory for p[%d]\n",2*nper); exit(1);}
    if ((sa=malloc(2*nper*sizeof(double)))==NULL) { printf("error allocating memory for sa[%d]\n",2*nper); exit(1);}
    if ((dl=malloc(2*nper*sizeof(double)))==NULL) { printf("error allocating memory for dl[%d]\n",2*nper); exit(1);}
    if ((sef=malloc(2*nper*sizeof(double)))==NULL) { printf("error allocating memory for sef[%d]\n",2*nper); exit(1);}
    if ((nx=malloc(dim*sizeof(double)))==NULL) { printf("error allocating memory for nx[%d]\n",dim); exit(1);}
    printf("nx dimension:%ld(%5.1lfMb)\n",dim,(float)dim/1024./1024.); printf("memory used:%ld\n",(dim+3*nper)*sizeof(double));
    for (tst=1; tst>0;) {
        printf("enter %d n's separated by spaces(0's to quit):",nper-1);
        for (i=0; i<nper-1; na[++i]=0) if ((tst=scanf("%lf",&na[i]))<1) break;
        printf("enter %d n's for females:",nper-1);
        for (i=nper-1; i<2*nper-2; na[++i]=0) if ((tst=scanf("%lf",&na[i]))<1) break;
        for (sumn=0,i=0; i<2*nper-2; i++) { sumn+=na[i]; tcap[i]=0; talive[i]=0;} tcap[nper-1]=0; talive[nper-1]=0;
        if (tst<1 || sumn<=0) break;
        printf("\nn(m)="); for (i=0; i<nper-1; i++) printf(" %lf",na[i]); printf("\n");
        printf("n(f)="); for (i=nper-1; i<2*nper-2; i++) printf(" %lf",na[i]); printf("\n");
        printf("enter %d survival rates:",nper-1); for (i=0; i<nper-1; i++) scanf("%lf",&sa[i]);
        printf("enter %d survival rates:",nper-1); for (i=nper-1; i<2*nper-2; i++) scanf("%lf",&sa[i]);
        printf("\nsrv(m)="); for (i=0; i<nper-1; i++) printf(" %lf",sa[i]); printf("\n"); 
        printf("srv(f)="); for (i=nper-1; i<2*nper-2; i++) printf(" %lf",sa[i]); printf("\n"); 
        printf("enter %d p's:",nper); for (i=0; i<nper; i++) scanf("%lf",&pa[i]);
        printf("enter %d p's:",nper); for (i=nper; i<2*nper; i++) scanf("%lf",&pa[i]);
        printf("\np(m)="); for (i=0; i<nper; i++) printf(" %lf",pa[i]); printf("\n");
        printf("p(f)="); for (i=nper; i<2*nper; i++) printf(" %lf",pa[i]); printf("\n");
        printf("enter %d dlta's:",nper); for (i=0; i<nper; i++) scanf("%lf",&dl[i]);
        printf("enter %d dlta's:",nper); for (i=nper; i<2*nper; i++) scanf("%lf",&dl[i]);
        printf("\ndlta(m)="); for (i=0; i<nper; i++) printf(" %lf",dl[i]); printf("\n");
        printf("dlta(f)="); for (i=nper; i<2*nper; i++) printf(" %lf",dl[i]); printf("\n");
        for (i=0;i<dim;i++) nx[i]=0;
        for (k=0; k<nper-1; k++) {
            printf("N[%d](m)=%f\n",k,na[k]); talive[k]+=na[k];
            if (na[k]>0) caphis(0,na[k],k+1,0,0); printf(" tcap,talive[%d]=%f %f\n",k,tcap[k],talive[k]);
            if (na[k+1]<0) na[k+1]=0;
            kk=k+nper-1;
            printf("N[%d](f)=%f\n",k,na[kk]);talive[kk]+=na[kk];
            if (na[kk]>0) caphis(0,na[kk],k+1,1,0); printf(" tcap,talive[%d]=%f %f\n",k,tcap[kk],talive[kk]);
            if (na[kk+1]<0) na[kk+1]=0;
        }
        printf("n="); for (k=0; k<nper; k++) printf(" %f",na[k]); printf("\n");
        for (i=1;i<dim ;i++) if (nx[i]>eps) {
            klmt=floor(.5+nx[i]); if (capflg==0) klmt=1;
            for (k=0; k<klmt; k++) {
                fprintf(fp,"%12.4lf :",nx[i]);
                for (j=(nper-1);j>=0;j--) fprintf(fp,"%c",chcodes[(i&(3<<(2*j)))>>(2*j)]); 
                fprintf(fp,";\n");
            }
        }
    }
    fprintf(fp,"proc estimate novar maxfn=32001 name=one;\n");
    fprintf(fp,"    pim;\n");
    fprintf(fp,"    phi(m);"); for (i=0,j=1; i<nper-1; i++) fprintf(fp," %d",j); fprintf(fp,";\n");
    fprintf(fp,"    phi(f);"); for (i=0,j=2; i<nper-1; i++) fprintf(fp," %d",j); fprintf(fp,";\n");
    fprintf(fp,"    cp(m);"); for (i=0,j=3; i<nper-2; i++) fprintf(fp," %d",j); fprintf(fp," %d;\n",j);
    fprintf(fp,"    cp(f);"); for (i=0; i<nper-2; i++) fprintf(fp," %d",j); fprintf(fp," %d;\n",j);
    fprintf(fp,"    pi;"); for (i=0; i<nper; i++) fprintf(fp," %d",++j); fprintf(fp,";\n");
    fprintf(fp,"    delta%c(m);"," 2"[remembersex]); for (i=0,j++; i<nper; i++) fprintf(fp," %d",j); fprintf(fp,";\n");
    fprintf(fp,"    delta%c(f);"," 2"[remembersex]); for (i=0; i<nper; i++) fprintf(fp," %d",j); fprintf(fp,";\n");
    fprintf(fp,"    design rows=%d cols=%d identity;\n",j,j);
    fprintf(fp,"    fixed; 0.5;\n");
    fprintf(fp,"    initial;\n");
     for (i=0;i<1;i++) fprintf(fp," %2.2f",sa[i]); fprintf(fp," ");
     for (i=0;i<1;i++) fprintf(fp," %2.2f",sa[i+nper-1]); fprintf(fp,"\n");
     for (i=1;i<=1;i++) fprintf(fp," %2.2f",pa[i]); fprintf(fp," ");
//     for (i=1;i<=1;i++) fprintf(fp," %2.2f",pa[i+nper]); fprintf(fp,"\n");
     for (i=0;i<nper-1;i++) fprintf(fp," .5"); fprintf(fp,"\n");
     for (i=0;i<1;i++) fprintf(fp," %2.2f",dl[i]); fprintf(fp," ");
//     for (i=0;i<1;i++) fprintf(fp," %2.2f",dl[i+nper]);
    fprintf(fp,";\nproc stop;\n");
    i=fclose(fp);  printf("\noutput saved to 'gencapunsex.out'\n");
}
