#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "status.h"
#include "modelc.h"
#define MAXINL 200

void model(FILE *F) {
    int i,j,k,iline,iistr,result,flg,idbg=0,icoht,fcap; 
	char tmpstr[2560],*pdest,sexcodes[4]="MFU";
    char wds[]="xxxx PROC INLI LABE COHO ", str_decl[]="declare", str_inline[]="inline";
    int count(char *s1, char x); int getcmd(FILE *x); void modout(void); void labels(FILE *x);
    void srverror(char *x); void srvwarn(char *x);
    ncoht=-1; ncons=0; normal=FALSE; addcel=FALSE; iistr=0; iline=FALSE; robust=0;
    ngrps=1; nage=1; nstrat=1;
    fprintf(G,"INPUT--%s\n",lststr);
    
    //              ALLOCATE MEMORY FOR N,OBS,SFUNCS
    printf("allocating memory: maxcht=%d\n",maxcht);
    if ((n=malloc((maxcht+1)*sizeof(double)))==NULL) srverror("allocating memory for N");
    if ((obs=malloc((maxcht+1)*sizeof(char*)))==NULL) srverror("allocating memory for OBS"); 
    if ((icov=malloc((maxcht+1)*sizeof(double**)))==NULL) srverror("allocating memory for ICOV"); 
    if ((caphis=malloc((maxcht+1)*sizeof(char**)))==NULL) srverror("allocating memory for CAPHIS"); 
    if ((p=malloc((maxcht+1)*sizeof(double*)))==NULL) srverror("allocating memory for P"); 
    for (i=0; i<=maxcht; n[i++]=0) {
        printf("allocating memory: nclass[%d]=%d\n",i,nclass[i]);
        if ((caphis[i]=malloc((nclass[i]+1)*sizeof(char*)))==NULL) srverror("allocating memory for CAPHIS()");
        if ((obs[i]=malloc((nclass[i]+1)*sizeof(double)))==NULL) srverror("allocating memory for OBS()");
        if ((icov[i]=malloc((nclass[i]+1)*sizeof(double*)))==NULL) srverror("allocating memory for OBS()");
        if ((p[i]=malloc((nclass[i]+1)*sizeof(double)))==NULL) srverror("allocating memory for P()"); 
        for (j=0; j<=nclass[i]; j++) {
            if ((caphis[i][j]=malloc(80*sizeof(char)))==NULL) srverror("allocating memory for CAPHIS(i,j)");
            if ((icov[i][j]=malloc(20*sizeof(double)))==NULL) srverror("allocating memory for icov(i,j)");
            strcpy(caphis[i][j],"uninit");
			obs[i][j]=0; for (k=0; k<20; k++) icov[i][j][k]=0;
        }
	}
    for (i=3; i<=lstwrd; i++) {
        if (strcmpi(words[i],"NPAR")==0) npar=atoi(words[i+2]);
        if (strcmpi(words[i],"NORMALIZE")==0) normal=TRUE;
        //  if (strcmpi(words[i],"ADDCELL")==0) addcel=TRUE;
        if (strcmpi(words[i],"NYRS")==0) {
            nyrs=atoi(words[i+2]);
            if ((t=malloc((nyrs+1)*sizeof(double)))==NULL) srverror("allocating memory for t"); tmem+=(nyrs+1)*sizeof(double);
            if ((nper=malloc((nyrs+1)*sizeof(int)))==NULL) srverror("allocating memory for nper"); tmem+=(nyrs+1)*sizeof(int);
            for (j=0; j<=nyrs; j++) { t[j]=1; nper[j]=0; }
        }                    
        if (strcmpi(words[i],"NAGE")==0) nage=atoi(words[i+2]);
        if (strcmpi(words[i],"NGROUPS")==0) ngrps=atoi(words[i+2]);
        if (strnicmp(words[i],"SEC",3)==0) 
            for (robust=1,j=i+2; j<=lstwrd; j++) 
                if (words[j][0]>='0' && words[j][0]<='9' && (j-i-1)<=nyrs) mp[j-i-1]=atoi(words[j]); 
        if (strnicmp(words[i],"INTER",5)==0) 
            for (flg=0, j=i+2; j<=lstwrd && flg==0 && (j-i)<nyrs; j++) 
                if (words[j][0]>='0' && words[j][0]<='9' && (j-i-1)<=nyrs) t[j-i-1]=atof(words[j]);
                else flg=1;
    }
    getcmd(F); for (i=0; i<=maxcht; i++) nclass[i]=0;
    while (stricmp(words[1],"PROC")!=0) {
		strcpy(tmpstr,words[1]); tmpstr[4]='\0'; pdest = strstr(wds,tmpstr); result=100;
        if(pdest!=NULL) result = pdest - wds + 1; 
        //printf("result=%d  %s pdest=%s wds=%s\n",result,words[1],pdest,wds);
        switch (result/5) {
        case 3: indent=2; iline=FALSE; labels(F); break;  // LABELS
        case 4: indent=2; iline=FALSE;                   // COHORT
           // n[++ncoht]=atof(words[3]); printf("\nINPUT--COHORT=%f\n",atof(words[3])); 
            i=getcmd(F); break;
        default: indent=3; 
            //printf("\nINPUT--%s %s\n",words[1],words[2]); 
            if (lstwrd<2) 
                srverror("expected- n capture-history"); 
            else {
                for (j=0,fcap=-1; j<strlen(words[1]); j++) if (words[1][j]>'0' && fcap<0) fcap=j;
                icoht=fcap+1;
                if (icoht>ncoht) ncoht=icoht;
                if (icoht<0) { printf("error - icoht<0\n"); exit(1);}
                j=++nclass[icoht]; 
                obs[icoht][j]=atof(words[2]); n[icoht]+=obs[icoht][j];
                if (lstwrd>2) for (k=3; k<=lstwrd; k++) icov[icoht][j][k-3]=atof(words[k]); 
                strcpy(caphis[icoht][j],words[1]);
                //printf("words=%s,%s\n",words[1],words[2]);
                //printf(" %s %f %f (%d,%d)\n",caphis[icoht][j],obs[icoht][j],icov[icoht][j][0],icoht,j);
            }
            getcmd(F); //printf("words:%s, %s, %s\n",words[1],words[2],words[3]);
        }
    }
    modout(); modnum=0;
    for (i=1; i<=ncoht; i++) {
        fprintf(G,"INPUT -- COHORT=%3.3f  /* first cap in %d */;\n",n[i],i);
        for (j=1; j<=nclass[i]; j++)
            fprintf(G,"INPUT -- %s %18.9f (%f);\n",caphis[i][j],obs[i][j],icov[i][j][0]);
        obs[i][++nclass[i]]=0; //strcpy(caphis[i][nclass[i]],"xxx");
    }
    //              ALLOCATE MEMORY FOR est arrays
    if ((chi=malloc(2*sizeof(double*)))==NULL) srverror("allocating memory for chi"); 
    for (i=0; i<2; i++) {
        if ((chi[i]=malloc((nyrs+1)*sizeof(double)))==NULL) srverror("allocating memory for phi[i]"); 
    }
}
