#include <math.h>
double dabs (double x);
double dmax (double x, double y);
double est(int nest, double *ppar);
void optmz2(double *a, int n, double *z, double sig, double *w, int *irx, int mk, double eps) {
/*    
C  *DECK OPTMZ2
C     SUBROUTINE OPTMZ2 IS CALLED BY OPTMIZ WHEN MAXIMIZING THE LOG-LIKELIHOOD FUNCTION.
 */
    int i,j,ii,jj,ij,mm,ir;
	double ti,v,tim,al,r,b,gm,y;
	ir=*irx;
    //  UPDATE FACTORS GIVEN IN A SIG*Z*Z-TRANSPOSE IS ADDED
    if (n>1) goto x10;
    a[1]+=sig*z[1]*z[1];
    ir=1;
    if (a[1]>0) goto x240;
    a[1]=0; ir=0; goto x240;
x10:
    if (sig>0) goto x130;
    if (sig==0 || ir==0) goto x240;
    ti=1/sig; jj=0; 
	if (mk!=0) {
    //                             L*W = Z ON INPUT
		for (j=1; j<=n; j++) {jj+=j; if (a[jj]!=0) ti+=(w[j]*w[j]/a[jj]); }
	}
	else {
		for (j=1; j<=n; j++) w[j]=z[j];
		for (j=1; j<=n; j++) {
			jj+=j; v=w[j]; 
			if (a[jj]<=0) w[j]=0;
			else {
				ti+=(v*v)/a[jj];
				if (j!=n) {
					ij=jj;
					for (i=j+1; i<=n; i++) { ij+=(i-1); w[i]-=v*a[ij]; }
				}
			}
		}
	}
    //   SET TI, TIM AND W
    if (ir<=0) goto x90;
    if (ti>0) goto x100;
    if ((mk-1)<=0) goto x130;
    goto x110;
x90:
    ti=0; ir=(-ir-1); goto x110;
x100:
    ti=eps/sig;
    if (eps==0) ir--;
x110:
    tim=ti; ii=jj; i=n; 
    for (j=1; j<=n; j++) {
        if (a[ii]!=0) tim=ti-(w[i]*w[i])/a[ii];
        w[i]=ti; ti=tim; ii-=i; i--;
    }
    mm=1; goto x140;
x130:
    mm=0; tim=1/sig;
x140:
    jj=0;   //              UPDATE A
    for (j=1; j<=n; j++) {
        jj+=j; ij=jj; v=z[j]; //       UPDATE A(J,J)
        if (a[jj]>0) goto x170;
        if (ir>0 || sig<0 || v==0) goto x160;
        ir=1-ir;
        a[jj]=v*v/tim;
        if (j==n) goto x240;
        for (i=j+1; i<=n; i++) { ij+=(i-1); a[ij]=z[i]/v; }
        goto x240;
x160:
        ti=tim; goto x220;
x170:
        al=v/a[jj]; ti=w[j]; if (mm==0) ti=tim+v*al;
        r=ti/tim; a[jj]*=r;
        if (r==0 || j==n) goto x230;
        //                   UPDATE REMAINDER OF COL J
        b=al/ti; 
		if (r<=4) for (i=j+1; i<=n; i++) { ij+=(i-1); z[i]-=v*a[ij]; a[ij]+=b*z[i];}
		else for (gm=tim/ti, i=j+1; i<=n; i++) { ij+=(i-1); y=a[ij]; a[ij]=b*z[i]+y*gm;	z[i]-=v*y;}
		tim=ti;
x220:
		continue;
	}
x230: 
    if (ir<0) ir=-ir;
x240: *irx=ir;
}
