#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include "status.h"
#include "modelc.h"
#define MAXINL 200

void getpim(FILE *F) {
    int getcmd(FILE *F); void srverror(char *x); void srvwarn(char *x);
    int i,j,ii,isex,ival,ircval=0,onedig=0,irow,icol,nphigh=0; 
    char tmplab[80],tmpfmt[80];
    double ncount=0; printf("\ngetpim: npar=%d nyrs=%d\n",npar,nyrs);
    // ALLOCATE MEMORY for PIM pointer arrays
    if ((jsrv=malloc(2*sizeof(double*)))==NULL) srverror("allocating memory for jsrv"); 
    if ((jp=malloc(2*sizeof(double*)))==NULL) srverror("allocating memory for jp"); 
    if ((jpi=malloc(nyrs*sizeof(double*)))==NULL) srverror("allocating memory for jpi"); 
    if ((jdlta=malloc(2*sizeof(double*)))==NULL) srverror("allocating memory for jdlta"); 
    for (i=0; i<2; i++) {
        if ((jsrv[i]=malloc(nyrs*sizeof(double)))==NULL) srverror("allocating memory for jsrv[i]"); 
        if ((jp[i]=malloc(nyrs*sizeof(double)))==NULL) srverror("allocating memory for jp[i]"); 
        if ((jdlta[i]=malloc(nyrs*sizeof(double*)))==NULL) srverror("allocating memory for jf[i]"); 
    }
    //              ALLOCATE MEMORY FOR SLABEL
    if ((slabel=malloc((nreal+2)*sizeof(char *)))==NULL) srverror("allocating memory for slabel"); 
    for (i=0; i<=(nreal+1); i++) {
        if ((slabel[i]=malloc((40)*sizeof(char)))==NULL) srverror("allocating memory for slabel(i)");
        j=sprintf(slabel[i],"Parameter%d",i);
    }
    for (isex=0; isex<2; isex++) {          // GET SURV PIMS
        ii=getcmd(F); indent=3; strcpy(tmplab,words[1]); 
        fprintf(G," INPUT -- %s ",lststr);  
        if (strnicmp(words[1],"PHI",3)!=0 && strnicmp(words[1],"SRV",3)!=0) srverror("expected PHI");
        ii=getcmd(F); indent=4; fprintf(G," INPUT -- %s\n",lststr); 
        for (i=0; i<nyrs-1; i++) {              // triangular matrix of pims
            ival=atoi(words[i+1]);
            jsrv[isex][i]=ival;
            if (ival>nrows) nrows=ival;
            if (ival>0) strcpy(slabel[ival],tmplab);
        }
    }
    for (isex=0; isex<2; isex++) {   // GET p PIMS
        ii=getcmd(F); indent=3; strcpy(tmplab,words[1]); fprintf(G," INPUT -- %s ",lststr); 
        if (strnicmp(words[1],"P",1)!=0 && strnicmp(words[1],"CP",2)!=0) srverror("expected P-'");
        ii=getcmd(F); indent=4; fprintf(G," INPUT -- %s\n",lststr); 
        if (lstwrd!=(nyrs-1)) srverror("not enough p pims'");
        for (j=0; j<lstwrd; j++) {
            ival=atoi(words[j+1]);
            jp[isex][j]=ival;
            if (ival>nrows) nrows=ival;
            if (ival>0) strcpy(slabel[ival],tmplab);
        }
    }
    // GET PI(prob animal is male) PIMS  
    ii=getcmd(F); indent=3; strcpy(tmplab,words[1]); fprintf(G," INPUT -- %s ",lststr); 
    if (strnicmp(words[1],"PI",2)!=0)	srverror("expected PI");
    if (strnicmp(words[1],"PI2",3)==0)	piopt=2;
    ii=getcmd(F); indent=4; fprintf(G," INPUT -- %s\n",lststr); 
    for (i=0; i<nyrs; i++) {
        ival=atoi(words[i+1]);
        jpi[i]=ival;
        if (ival>nrows) nrows=ival;
        if (ival>0) strcpy(slabel[ival],tmplab);
    }
    
    for (isex=0; isex<2; isex++) {   // GET DLTA(prob sex can be ascertained) PIMS
        ii=getcmd(F); indent=3; strcpy(tmplab,words[1]); fprintf(G," INPUT -- %s ",lststr); 
        if (strnicmp(words[1],"D",1)!=0) srverror("expected DLTA");
        if (strnicmp(words[1],"DELTA2",6)==0) { 
            dltaopt=1; 
            fprintf(G,"\n\n *** INFO *** alternate DELTA specified - ");
            fprintf(G," DELTA=1 once sex is known\n\n"); 
        }
        if (strnicmp(words[1],"DELTAnone",9)==0) { 
            dltaopt=2; 
            fprintf(G,"\n\n *** INFO *** No DELTA's used in prob. structure.\n\n");
        }
        else {
            ii=getcmd(F); indent=4; fprintf(G," INPUT -- %s\n",lststr); 
            for (i=0; i<nyrs; i++) {
                ival=atoi(words[i+1]);
                jdlta[isex][i]=ival;
                if (ival>nrows) nrows=ival;
                if (ival>0) strcpy(slabel[ival],tmplab);
            }
        }
    }
    ii=getcmd(F); ncols=nrows; indent=3; idmat=0; ircval=0; fprintf(G," INPUT -- %s\n",lststr); 
    for (i=1; i<=lstwrd; i++) {
        if (strnicmp(words[i],"IDENT",5)==0) idmat=1;
        if (strnicmp(words[i],"ROWCOLVAL",9)==0) ircval=1;
        if (strnicmp(words[i],"ONEDIG",6)==0) onedig=1;
        if (strnicmp(words[i],"ROWS",4)==0) nrows=atoi(words[i+2]);
        if (strnicmp(words[i],"COLS",4)==0) ncols=atoi(words[i+2]);
    }
    if ((desmat=malloc((nrows+1)*sizeof(double*)))==NULL) srverror("allocating memory for desmat"); 
    for (i=0; i<=nrows; i++) {
        if ((desmat[i]=malloc((ncols+1)*sizeof(double)))==NULL) srverror("allocating memory for desmat[i]"); 
        tmem+=(nstrat+1)*sizeof(double);
        for (j=0; j<=ncols; j++) desmat[i][j]=0;
        if (i<=ncols && idmat==1) desmat[i][i]=1;
    }
    tmem+=(nstrat+1)*sizeof(double*);fprintf(stderr," *** INFO-- desmat: memory used:%ld\n",tmem);
    //printf("ircval=%d idmat=%d nrows=%d ncols=%d\n",ircval,idmat,nrows,ncols);
    if (ircval==1) {
        irow=1; ii=getcmd(F); fprintf(G," INPUT -- %s\n",lststr); 
        for (irow=atoi(words[1]); irow>0; ) {
            icol=atoi(words[2]); desmat[irow][icol]=atof(words[3]);
            ii=getcmd(F); irow=0;
            if (words[1][0]>='0' && words[1][0]<='9') irow=atoi(words[1]);
        }
    }
    if (idmat==0 && ircval==0) {
        for (i=1; i<=nrows; i++) {
            ii=getcmd(F); fprintf(G," INPUT -- %s\n",lststr); 
            for (j=1; j<=lstwrd; j++) desmat[i][j]=atof(words[j]);
        }
        ii=getcmd(F); fprintf(G," INPUT -- %s\n",lststr); 
    }
    if (idmat!=1 || ncols !=nrows) {
        fprintf(G,"DESIGN Matrix:\n"); printf("DESIGN Matrix:\n");
        for (i=1; i<=nrows; i++) {
            strcpy(tmpfmt,"%1.0f");
            if (onedig==0) strcpy(tmpfmt," %4.1f");
            for (j=1; j<=ncols; j++) fprintf(G,tmpfmt,desmat[i][j]);
            for (j=1; j<=ncols; j++) printf(tmpfmt,desmat[i][j]);
            fprintf(G,"\n");  printf("\n");
        }
        fprintf(G,"\n"); 
    }
	//ii=getcmd(F);
}
