#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

int main(int argc, char **argv){
/* simunsex.c
        DATE WRITTEN: 8/4/2003
        PROGRAMMER  : J. HINES
        PURPOSE     : simulate data for  JOLLY-with unsexed captures MODEL
*/
    long nyrs,*n,**obs,*nclass,i,j,k,sex,dead,captured,ksave,sexknown,timeflg=0,remembersex=0;  
    char sexchar[2]={'M','F'},tmpcaphis[80],***caphis,adlta[2][6]={"DELTA","DELTA2"};
    FILE *f,*G;
    double **srv,**p,*pi,**dlta;
    
    for (i=1; i<argc; i++) {
        printf("arg(%d)=%s\n",i,argv[i]);
        if (strncmp(argv[i],"rem",3)==0) {
            printf("*** sex stays known once determined\n");
            remembersex=1;
        }
        if (strncmp(argv[i],"time",4)==0) timeflg=1;
    }
    
    if ((f=fopen("simunsex.inp","r"))==NULL) {
        printf("\nerror opening survunsex.inp\n"); exit(1);
    }
    fscanf(f,"%d",&nyrs);  if(nyrs<0) {nyrs=-nyrs; timeflg=1; }
    printf("nyrs:%ld\n",nyrs);
    srv=malloc(2*sizeof(double*)); srv[0]=malloc(nyrs*sizeof(double)); srv[1]=malloc(nyrs*sizeof(double));
    p=malloc(2*sizeof(double*)); p[0]=malloc(nyrs*sizeof(double)); p[1]=malloc(nyrs*sizeof(double));
    dlta=malloc(2*sizeof(double*)); dlta[0]=malloc(nyrs*sizeof(double)); dlta[1]=malloc(nyrs*sizeof(double));
    pi=malloc((nyrs+1)*sizeof(double)); n=malloc((nyrs+1)*sizeof(long));
    for (i=1; i<nyrs; i++) fscanf(f,"%lf",&srv[0][i-1]);
    printf("srv:"); for (i=1; i<nyrs; i++) printf(" %lf",srv[0][i-1]); printf("\n");
    for (i=1; i<nyrs; i++) fscanf(f,"%lf",&srv[1][i-1]);
    printf("srv:"); for (i=1; i<nyrs; i++) printf(" %f",srv[1][i-1]); printf("\n");
    for (i=1; i<nyrs; i++) fscanf(f,"%lf",&p[0][i-1]);
    printf("p:"); for (i=1; i<nyrs; i++) printf(" %f",p[0][i-1]); printf("\n");
    for (i=1; i<nyrs; i++) fscanf(f,"%lf",&p[1][i-1]);
    printf("p:"); for (i=1; i<nyrs; i++) printf(" %f",p[1][i-1]); printf("\n");
    for (i=1; i<=nyrs; i++) fscanf(f,"%lf",&pi[i-1]);
    printf("pi:"); for (i=1; i<=nyrs; i++) printf(" %f",pi[i-1]); printf("\n");
    for (i=1; i<=nyrs; i++) fscanf(f,"%lf",&dlta[0][i-1]);
    printf("dlta:"); for (i=1; i<=nyrs; i++) printf(" %f",dlta[0][i-1]); printf("\n");
    for (i=1; i<=nyrs; i++) fscanf(f,"%lf",&dlta[1][i-1]);
    printf("dlta:"); for (i=1; i<=nyrs; i++) printf(" %f",dlta[1][i-1]); printf("\n");
    for (i=1; i<=nyrs; i++) fscanf(f,"%ld",&n[i-1]);
    printf("n:"); for (i=1; i<=nyrs; i++) printf(" %ld",n[i-1]); printf("\n");
    
    fclose(f); n[nyrs]=1;
    obs=malloc((nyrs+1)*sizeof(long*)); caphis=malloc((nyrs+1)*sizeof(char**));
    nclass=malloc((nyrs+1)*sizeof(long));
    for (i=0; i<=nyrs; i++) { 
	if((obs[i]=malloc((n[i]+1)*sizeof(long)))==NULL) {printf("error allocating obs(%d)\n",i); exit(1);}
	if((caphis[i]=malloc((n[i]+1)*sizeof(char*)))==NULL) {printf("error allocating caphis(%d)\n",i); exit(1);}
        nclass[i]=0; 
        for (j=0; j<=n[i]; j++) { 
            obs[i][j]=0; 
            caphis[i][j]=malloc((nyrs+1)*sizeof(char));
            for (k=0; k<nyrs; k++) caphis[i][j][k]='0';
            caphis[i][j][nyrs]=0; 
        }
    }
    tmpcaphis[nyrs]=0;	
    if ((G=fopen("simunsex.out","w"))==NULL) {
        printf("\nerror opening survunsex.out\n"); exit(1);
    }
    printf("Parameters:\n");
    printf("\n Simulation parameters:\n");
    printf("     ======== Males ========     ======== Females =======\n");
    printf("  i   phi       p       dlta       phi        p      dlta     pi\n");
    for (i=1; i<nyrs; i++) 
        printf(" %3d %8.4f %8.4f %8.4f   %8.4f %8.4f %8.4f  %8.4f\n",i,
                srv[0][i-1],p[0][i-1],dlta[0][i-1],
                srv[1][i-1],p[1][i-1],dlta[1][i-1],pi[i-1]);
    
    srand( (unsigned)time( NULL ) );
    
    for (i=0; i<nyrs; i++) {
        nclass[i]=0;
        for (j=0; j<n[i]; j++) {        // all animals in cohort are captured initially
            sex=0; sexknown=0;
            if ((rand()/(float)RAND_MAX)<pi[i]) sex=1;//    determine sex of animal
            tmpcaphis[i]=sexchar[sex];
            // check if sex is known
            if ((rand()/(float)RAND_MAX)>=dlta[sex][i]) tmpcaphis[i]='U'; else sexknown=1;
            for (k=i+1,dead=0; k<nyrs; k++)  {
                tmpcaphis[k]='0'; if (remembersex==0) sexknown=0;
                if ((rand()/(float)RAND_MAX)>=srv[sex][k-1]) dead=1; 
                captured=((rand()/(float)RAND_MAX)<p[sex][k-1]?1:0);
                if(!dead && captured>0)  {
                    tmpcaphis[k]=sexchar[sex];
                    if (sexknown==0) 
                        if ((rand()/(float)RAND_MAX)>=dlta[sex][i]) tmpcaphis[k]='U';
                        else sexknown=1;
                }
            }
            //                         summarize capture-histories
            for (ksave=-1,k=0; k<j; k++) { if (strcmp(tmpcaphis,caphis[i][k])==0) ksave=k; }
            if (ksave<0) { strcpy(caphis[i][nclass[i]],tmpcaphis); obs[i][nclass[i]]=1; nclass[i]++; }
            else ++obs[i][ksave];
        }
        tmpcaphis[i]='0';
    }
    fprintf(G,"PROC TITLE 'Simulated data from simunsex.c';\n");
    fprintf(G,"PROC MODEL nyrs=%d;\n",nyrs);
    for (i=0; i<nyrs; i++) {
//        fprintf(G,"COHORT=%ld;\n",n[i]);
        for (j=0; j<nclass[i]; j++) fprintf(G," %6ld : %s;\n",obs[i][j],caphis[i][j]);
        nclass[i]++;
    }
    fprintf(G,"PROC ESTIMATE NOVAR MAXFN=32001 NAME=ONE;\nPIM;\n"); j=1;
    fprintf(G,"PHI(M);");  for (i=1; i<nyrs; i++) { fprintf(G," %d",j); if (timeflg>0 && i<(nyrs-1)) ++j; } fprintf(G,";\n");
    fprintf(G,"PHI(F);");  for (i=1,++j; i<nyrs; i++) { fprintf(G," %d",j); if (timeflg>0 && i<(nyrs-1)) ++j;} fprintf(G,";\n");
    fprintf(G,"CP(M);");  for (i=1,++j; i<(nyrs-1); i++) { fprintf(G," %d",j); if (timeflg>0 && i<(nyrs-2)) ++j;} 
    if (timeflg==0) fprintf(G," %d;\n",j); else fprintf(G," -1;\n");
    fprintf(G,"CP(F);");  for (i=1,++j; i<(nyrs-1); i++) { fprintf(G," %d",j); if (timeflg>0 && i<(nyrs-2)) ++j;} 
    if (timeflg==0) fprintf(G," %d;\n",j); else fprintf(G," -1;\n");
    fprintf(G,"PI;");  for (i=1; i<=nyrs; i++) fprintf(G," %d",++j); fprintf(G,";\n");
    fprintf(G,"%s(M);",adlta[remembersex]); for (i=1,++j; i<=nyrs; i++) { fprintf(G," %d",j); if (timeflg>0 && i<nyrs) ++j;} fprintf(G,";\n");
    fprintf(G,"%s(F);",adlta[remembersex]); for (i=1,++j; i<=nyrs; i++) {fprintf(G," %d",j); if (timeflg>0 && i<nyrs) ++j;} fprintf(G,";\n");
    fprintf(G,"DESIGN ROWS=%d COLS=%d IDENTITY;\n",j,j);
    if (timeflg>0) {
        fprintf(G,"INITIAL;\n");
        for (i=1; i<nyrs; i++) fprintf(G," %2.2f",(srv[0][i-1]>=1?0.994:srv[0][i-1])); fprintf(G,"\n");
        for (i=1; i<nyrs; i++) fprintf(G," %2.2f",(srv[1][i-1]>=1?0.994:srv[1][i-1])); fprintf(G,"\n");
        for (i=1; i<nyrs; i++) fprintf(G," %2.2f",(p[0][i-1]>=1?0.994:p[0][i-1])); fprintf(G,"\n");
        for (i=1; i<nyrs; i++) fprintf(G," %2.2f",(p[1][i-1]>=1?0.994:p[1][i-1])); fprintf(G,"\n");
        for (i=1; i<=nyrs; i++) fprintf(G," %2.2f",(pi[i-1]>=1?0.994:pi[i-1])); fprintf(G,"\n");
        for (i=1; i<nyrs; i++) fprintf(G," %2.2f",(dlta[0][i-1]>=1?0.994:dlta[0][i-1])); fprintf(G,"\n");
        for (i=1; i<nyrs; i++) fprintf(G," %2.2f",(dlta[1][i-1]>=1?0.994:dlta[1][i-1])); fprintf(G,"\n");
    }
    fprintf(G,"PROC STOP;\n");
    fclose(G);
}
