#include <stdio.h>
#include <time.h>
#include <string.h>
#include <ctype.h>
#include <stdlib.h>
#include "headst.h"
#include "status.h"
#include "modelc.h"

/*
C   SURVIV IS A FORTRAN 77 PROGRAM TO ESTIMATE SURVIVAL RATES
C   FROM A USER SPECIFIED MODEL.
C   THIS SOURCE TO BE COMPILED ON THE UNIX OPERATING SYSTEM
*/
int main(int argc, char **argv) {
    int i,result; char tmpstr[256],upstr[256],filein[80]="",fileout[80]="survunsex.out",*pdest; 
	FILE *F;
	int getcmd(FILE *x); void headng(void); void estmat(int i, FILE *F); 
	void dotest(FILE *x); void simlte(); 
	void model(FILE *x); void title(void);
	void getmax(FILE *x); void srverror(char *x); void srvwarn(char *x);
	char procs[]="xxxx MODE BROW ESTI TEST SIMU SAMP TITL BMDP IDEN STOP ";
    
    modflg=FALSE; cplflg=FALSE; detail=TRUE;simult=FALSE;bmdcal=FALSE;noecho=FALSE;
    eofflg=FALSE;nxtchr=1;lstchr=0;lcmdst=1;lcmded=0;npage=0;lines=0;maxlin=9999; vcopt=0;
	tmem=0; maxcht=100,maxinl=0,maxmod=0; cmdeof=0; modnum=0; debug=1; ntrace=200; scaleopt=FALSE;

    strcpy(version,"Version 1.0 ("); strcat(version,__DATE__); strcat(version,")");

	for (i=0; i<MAXWRD; i++) {
		if ((words[i]=malloc(80))==NULL) srverror("allocating memory for words"); tmem+=80;
	} 

    if (argc<2) { fprintf(stderr,"\n usage: survunsex infile outfile\n"); exit(1); }
	i=1; strcpy(upstr,strupr(argv[i])); strcpy(filein,argv[i]);
	if (strncmp(upstr,"I=",2)==0) strcpy(filein,argv[i]+2); 
	if ((F=fopen(filein,"r"))==NULL) {
		fprintf(stderr,"\n *** ERROR: input file (%s) not found\n",filein); 
		exit(1); 
	}
	if (argc>2) {
		i=2; strcpy(upstr,strupr(argv[i])); strcpy(fileout,argv[i]);
		if (strncmp(upstr,"L=",2)==0) strcpy(fileout,argv[i]+2); 
	}
	if ((G=fopen(fileout,"w"))==NULL) { fprintf(stderr,"\n *** ERROR: opening output file\n"); exit(1); }
	if (argc>3) {
		i=3; ntrace=atoi(argv[i]); if (ntrace==0) ntrace=250;
		
	}
	fprintf(stderr," *** INFO: infile=%s outfile=%s\n",filein,fileout);

	getmax(F); cmdeof=0;
	
    //noecho=(strcmp(upstr,"NOECHO")==0);
    //if (strnicmp(upstr,"LINES=",6)==0) maxlin=atoi(upstr+6);

	if (!cplflg) {	//              ALLOCATE MEMORY FOR modsav structure
		if ((modsav=malloc((maxmod+1)*sizeof(*modsav)))==NULL) srverror("allocating memory for modsav");
		tmem+=((maxmod+1)*sizeof(*modsav));
		for (i=0; i<=maxmod; i++) {
			if ((modsav[i].modnam=malloc(128*sizeof(char)))==NULL) srverror("allocating memory for modsav[].modnam");
			sprintf(modsav[i].modnam,"SUBMODEL%d",i);
			if ((modsav[i].ipar=malloc((npar+1)*sizeof(double)))==NULL) srverror("allocating memory for modsav[].ipar"); 
			tmem+=128*sizeof(char)+(npar+1)*sizeof(double);
		}
		fprintf(stderr," *** INFO-- MODSAVE: memory used:%ld\n",tmem);
	}

    tcumul=0.; tstart=clock();
    i=getcmd(F); 
    if (stricmp(words[1],"PROC")!=0) { 
        printf("error- PROC statement missing.\n");
        printf("------ %s\n",words[1]);
        exit(1);
    }
    while (cmdeof==0) {
		//printf("words[1]=%s\n",words[1]);
		if (stricmp(words[1],"PROC")==0) {
			indent=1;
			if (stricmp(words[3],"DEBUG")==0) debug=1000;
			else debug=-1;
			strncpy(tmpstr,strupr(words[2]),4); 
			tmpstr[4]='\0';	pdest = strstr(procs,tmpstr); result = pdest - procs + 1;
			switch (result/5) {
			case 1: model(F); 
				break;
			case 2: srverror("\n *** ERROR: BROWNIE not implemented in survunsex\n"); // brown(); break;
			case 3: estmat(1,F); 
				break;
			case 4: 
				dotest(F); break;
			case 5: simult=TRUE; simlte(); simult=FALSE; 
				i=getcmd(F); break;
			case 6: srverror("SAMPLESIZE not implemented in survunsex"); // samsz2(F); break;
			case 7: title(); headng(); 
				fprintf(G,"INPUT--%s\n",lststr); 
				i=getcmd(F);
				break;
			case 8: srverror("BMDPAR not implemented in survunsex\n");  // bmdpar(); break;
			case 9: srverror("IDENTF not implemented in survunsex\n");  // identf(F); break;
			case 10: 
				fprintf(stderr,"\n     CPU time in minutes for this job was %8.2f\n",tcumul/60.);
				fprintf(stderr,"          E X E C U T I O N   S U C C E S S F U L\n");
				fprintf(G,"\n     CPU time in minutes for this job was %8.2f\n",tcumul/60.);
				fprintf(G,"\n          E X E C U T I O N   S U C C E S S F U L\n");
				exit(0);
			default: fprintf(G,"INPUT--%s\n",lststr); srvwarn("unknown procedure"); i=getcmd(F);
			}
		}
    tstop=clock();
    fprintf(G,"\n     CPU time in seconds for the last procedure was %8.2f\n",(tstop-tstart)/CLOCKS_PER_SEC);
    tcumul+=(tstop-tstart)/CLOCKS_PER_SEC; 	tstart=tstop;
    }
    //	free(nper); 
    free(n); 
    for (i=0; i<=maxcht; i++) free(obs[i]);
    for (i=0; i<=maxcht; i++) free(p[i]);
    if (maxcht>0) { free(obs); free(t); free(p);}
    
    for (i=0; i<=(npar+1); i++) free(slabel[i]); free(slabel);
    for (i=0; i<=maxmod; i++) {free(modsav[i].modnam); free(modsav[i].ipar);} free(modsav);
    for (i=0; i<MAXWRD; i++) free(words[i]); 
    fprintf(stderr,"\n          E X E C U T I O N   S U C C E S S F U L\n");
    fprintf(G,"\n          E X E C U T I O N   S U C C E S S F U L\n");
    return(0);
}