#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include <math.h>
#include "status.h"
#include "modelc.h"
void varcov(double *g, double *h, double *ppar, int itran1) {
    double ss(int i); double est(int np, double *ppar); double dabs(double x);
    int matinv(double *h, double *g, int ijobiv, int n); 
    void vcdlta(double *h, double *ppar, int itran1); void srverror(char *x); void srvwarn(char *x);
    
    double ***parpi,**vcmat,parval,lci,uci,separ,xll,x,y,x1;
    int i,j,k,l,m,ijobiv=1,tmem1,ierinv=0;  char beta_or_par[10]="Parameter";
	
    /*      SUBROUTINE covar computes the var-covar matrix using 
       Finite-difference Approximations of Derivatives (Central difference approximations)*/
    int ii,jj ; double ETA=2e-16, eps; //double ETA=.1e-12, eps;
    double fHiHj, fHihj, fhiHj, fhihj, fx, f2H, fH, f2h, fh;
    double *hh,**Params;  

    //              ALLOCATE MEMORY FOR VCMAT
    printf("allocating memory for vcmat...\n");
    if ((vcmat=malloc((npar+1)*sizeof(double *)))==NULL) srverror("allocating memory for vcmat");
    for (i=0; i<=npar; i++) {
        if ((vcmat[i]=malloc((npar+1)*sizeof(double)))==NULL) srverror("allocating memory for vcmat");
    }
    tmem+=(npar+1)*sizeof(double *)+(npar+1)*(npar+1)*sizeof(double);
    //fprintf(stderr," *** INFO-- VCMAT: memory used:%ld\n",tmem);

    ijobiv=1; notran=FALSE; itrans=itran1;

    if (idmat==1) {
        for (i=1; i<=nest; i++) ppar[i]=ss(i);
        notran=TRUE; itran1=itrans; itrans=0;
    }
    for (i=1; i<=nest; i++) par[i]=ppar[i];

	if (vcopt<2) {
      if (idmat==1) {	
		fprintf(G,"\n   SURVIV varcov procedure...\n");
	
		//                  SET CELL PROBABILITIES TO FINAL PARAMETER VALUES
		xll=est(nest,ppar);
		//         FILL PARPI (PARTIALS OF CELL PROBABILITIES WRT PARAMETERS) WITH THE CELL PROBABILITIES FOR PARAMETER ESTIMATES
		//         THEN THE P ARRAY CAN HOLD THE CELL PROBABILITIES FOR THE PERTURBATED PARAMETER VALUES,
		//         AND THE NUMERICAL PARTIALS CAN BE CALULATED	
		if ((parpi=malloc((nest+1)*sizeof(double **)))==NULL) srverror("allocating memory for parpi");
		tmem1=tmem; tmem+=(nest+1)*sizeof(double **);
		// NOW CALCULATE PARTIALS OF CELL PROBABILITIES WRT PARAMETERS
		for (i=0; i<=nest; i++) {
			if ((parpi[i]=malloc((ncoht+1)*sizeof(double *)))==NULL) srverror("allocating memory for parpi(x)");
			tmem+=(ncoht+1)*sizeof(double *); 
			for (j=0; j<=ncoht; j++) {
				if ((parpi[i][j]=malloc((nclass[j]+1)*sizeof(double)))==NULL) srverror("allocating memory for parpi(x,x)");
				tmem+=(nclass[j]+1)*sizeof(double);
				for (k=1; k<=nclass[j]; k++) parpi[i][j][k]=p[j][k];
			}
		} 
		//fprintf(stderr,"\n *** INFO-- PARPI: memory used:%ld\n",tmem); tmem1=tmem-tmem1;
		for (i=1; i<=nest; i++) {
			parval=ppar[i];
			if (idmat==1)
				if (dabs(parval)>0.00005) ppar[i]*=0.9999;
				else ppar[i]=((parval<0)? -.0001:.0001);
			else ppar[i]+=.00001;
			xll=est(nest,ppar);
			for (j=1; j<=ncoht; j++)
				for (k=1; k<=nclass[j]; k++) parpi[i][j][k]=(p[j][k]-parpi[i][j][k])/(parval-ppar[i]);
			ppar[i]=parval;
		}
		//         SET CELL PROBABILITIES BACK TO VALUES FOR PARAMETER ESTIMATES
		//         THESE VALUES ARE NEEDED FOR FORMATION OF INFORMATION MATRIX
		//         IN THE ARRAY H
		xll=est(nest,ppar);
		//         CONSTRUCT INFORMATION MATRIX IN ARRAY H
		for (l=1; l<=nest; l++, j=fprintf(stderr,"VC %7.2f%% done  \r",l*100./(float)(nest+1))) 
			for (m=1; m<=l; m++) {
				k=l*(l-1)/2+m; h[k]=0; 
				for (i=1; i<=ncoht; i++) {
					for (parval=0,j=1; j<=nclass[i]; j++) {
						//if (p[i][j]>0 && dabs(parpi[l][i][j])>0. && dabs(parpi[m][i][j])>0.)
						//    parval+=parpi[l][i][j]*parpi[m][i][j]/p[i][j];
						if (p[i][j]>0.)
							parval+=parpi[l][i][j]*parpi[m][i][j]/p[i][j];
					}
					h[k]+=n[i]*parval;
				}
			}
		for (i=0; i<=nest; i++) { 
			for (j=0; j<=ncoht; j++) free(parpi[i][j]);
			free(parpi[i]);
		} 
		free(parpi); tmem-=tmem1; fprintf(stderr,"\n *** INFO-- memory=%ld\n",tmem);
	
	  }  //  end if (idmat==1)
	  else {           
	    fprintf(G,"\n      PRESENCE varcov procedure...\n");
		// set up covariance matrix of beta parameters
		printf("Computing varcov matrix...\n"); strcpy(beta_or_par,"Beta      ");

		for (j=5; j<30; j++) for (i=9; i>0; i--) { x=i*pow(10,-j); y=x+1.; if (y!=1.) x1=x; } 
		ETA=x1;	eps=pow(ETA, 1.0/3.0);  //  ETA=machine precision (smallest x, such that x+1 not = 1)
		//eps=pow(pow(10.0, -6), 1.0/3.0);

		Params=(double**) malloc((nest+2)*sizeof(double*)); 
		hh = (double*) malloc((nest+2)*sizeof(double)); 
		for (ii=0; ii<=(nest+1); ii++) Params[ii]=(double*) malloc((nest+2)*sizeof(double));
		for (ii=0; ii<nest; ii++) {
			Params[0][ii+1]=ppar[ii+1]; hh[ii] = eps*(1.0+fabs(Params[0][ii+1]));
			//printf("hh(%d)=%26.20e\n",ii,hh[ii]);
		}

		for (ii=0; ii<nest; ii++) { 
			for (jj=1; jj<=nest; jj++) Params[ii+1][jj] = Params[0][jj];
			fx = est(nest,Params[0]);
			Params[ii+1][1+ii] = Params[0][1+ii] + 2*hh[ii]; f2H = est(nest,Params[ii+1]);
			Params[ii+1][1+ii] = Params[0][1+ii] + hh[ii];    fH = est(nest,Params[ii+1]);
			Params[ii+1][1+ii] = Params[0][1+ii] - 2*hh[ii]; f2h = est(nest,Params[ii+1]);
			Params[ii+1][1+ii] = Params[0][1+ii] - hh[ii];    fh = est(nest,Params[ii+1]);
			vcmat[ii+1][ii+1] = (-f2H + 16.0*fH - 30.0*fx + 16.0*fh - f2h) / (12.0*hh[ii]*hh[ii]);
			fHiHj = ((fH-fx)/hh[ii] - (fx-fh)/hh[ii])/hh[ii];
			Params[ii+1][1+ii] = Params[0][1+ii];
			for (jj=ii+1; jj<nest; jj++) {
				Params[ii+1][1+ii] = Params[0][1+ii] + hh[ii];
				Params[ii+1][1+jj] = Params[0][1+jj] + hh[jj];
				fHiHj = est(nest,Params[ii+1]);      
				Params[ii+1][1+ii] = Params[0][1+ii] + hh[ii];
				Params[ii+1][1+jj] = Params[0][1+jj] - hh[jj];
				fHihj = est(nest,Params[ii+1]);      
				Params[ii+1][1+ii] = Params[0][1+ii] - hh[ii];
				Params[ii+1][1+jj] = Params[0][1+jj] + hh[jj];
				fhiHj = est(nest,Params[ii+1]);      
				Params[ii+1][1+ii] = Params[0][1+ii] - hh[ii];
				Params[ii+1][1+jj] = Params[0][1+jj] - hh[jj];
				fhihj = est(nest,Params[ii+1]);
				Params[ii+1][1+ii] = Params[0][1+ii];
				Params[ii+1][1+jj] = Params[0][1+jj];
				vcmat[jj+1][ii+1]=vcmat[ii+1][jj+1]= (fHiHj - fHihj - fhiHj + fhihj) / (4*hh[ii]*hh[jj]);
			}
			if (vcmat[ii+1][ii+1]==0.) vcmat[ii+1][ii+1]=eps;
		}
		for (l=1; l<=nest; l++) for (m=1; m<=l; m++) h[l*(l-1)/2+m]=vcmat[l][m];
		for (ii=1; ii<=(nest+1); ii++) free(Params[ii-1]); free(Params); free(hh);
	  }    //  end if else (idmat==1)
	}  //  end if vcopt<2
	else
	  fprintf(G,"\n         Hessian used for var-cov computation...\n");
	
    // INVERT INFORMATION MATRIX IN H TO OBTAIN THE VAR-COV MATRIX IN H
    printf("inverting info matrix...\n");
    if (nest>0) ierinv=matinv(h,g,ijobiv,nest);
    else ierinv=0;
    if (ierinv==130) {
        srvwarn("Variance-covariance matrix not positive-definite for Model");
        srvwarn("Ignore standard errors and V-C matrix.\n");
        srvwarn("Check to be sure the parameters are identifiable, but the problem may just be ill-conditioned.\n");
    }
	
    // PRINT THE ESTIMATES, STANDARD ERRORS, AND CONFIDENCE INTERVALS
    if (detail) {
        fprintf(G,"\n\n                                                         95%% Confidence Interval\n");
        fprintf(G,"   I       %s             S(i)     Standard Error    Lower         Upper\n",beta_or_par);
        fprintf(G,"  ---  -------------------- ------------ ------------ ------------ ------------\n");
    }
    for (i=1; i<=ncols; i++) {
        separ=sqrt(h[i*(i-1)/2+i]);
        if (detail) {
            if (idmat!=1) {
		        lci=ppar[i]-1.96*separ; uci=ppar[i]+1.96*separ;
				fprintf(G,"%4d %-20s%12.6f %12.6g %12.6g %12.6g\n",i,slabel[i],ppar[i],separ,lci,uci);
			}
            else {
		        lci=ss(i)-1.96*separ; uci=ss(i)+1.96*separ;
				fprintf(G,"%4d   %-20s%13.6f %12.6g %12.6g %12.6g\n",i,slabel[i],ss(i),separ,lci,uci);
			}
            }
        if (simult) ppar[i]=separ;
    }
    // PRINT VARIANCE-COVARIANCE MATRIX
    
    if (detail) {
        if (!novar) {
            if (idmat!=1) fprintf(G,"\n  Beta "); else fprintf(G,"\n       ");
            fprintf(G,"Variance-Covariance matrix of estimates on diagonal and below,\n");
            //fprintf(G,  "      Correlation matrix of estimates above diagonal.\n");
			for (l=1; l<=nest; l++) for (m=1; m<=l; m++) vcmat[l][m]=vcmat[m][l]=h[l*(l-1)/2+m];
            fprintf(G," ---+----------------------------------------------------------------\n");
            for (i=1; i<=nest; i++) {
                fprintf(G,"%26.16e",vcmat[1][i]);
                for (j=2; j<=npar; j++) {
                    fprintf(G,"%26.16e",vcmat[j][i]);
                    if (j%10==0 || j==npar) fprintf(G,"\n");
                }
				fprintf(G,"\n");
            }
        }
        if (idmat!=1) vcdlta(h,ppar,itran1);
    }
    for (i=0; i<=npar; i++) free(vcmat[i]); free(vcmat); 
    tmem-=((npar+1)*sizeof(double *)+(npar+1)*(npar+1)*sizeof(double));
} 