#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include "status.h"
#include "modelc.h"
#define EPS .000001

double dm(int i, int j) {
	double v=desmat[i][j];
	if (v < -100) v=icov[0][0][(int)floor(-v-101)];
	return(v);
}
void vcdlta(double *h, double *ppar, int itran1) {
	double **vcmat,**tmp,**grad,parval,sm,sm2,lci,uci,separ,xphi,v;
	int i,j,k,jj,mpar;
	double dabs(double x); void srverror(char *x); void srvwarn(char *x);

	mpar=nrows; if (ncols>nrows) mpar=ncols;
	if ((vcmat=malloc((mpar+1)*sizeof(double *)))==NULL) srverror("allocating memory for vcmat\n");  
	tmem+=(mpar+1)*sizeof(double *);
	for (i=0; i<=mpar; i++) {
		if ((vcmat[i]=malloc((mpar+1)*sizeof(double)))==NULL) srverror("allocating memory for vcmat()");  
		tmem+=(mpar+1)*sizeof(double);
    } 
	//fprintf(stderr," *** INFO-- VCMAT: memory used:%ld\n",tmem);
	if ((grad=malloc((mpar+1)*sizeof(double *)))==NULL) srverror("allocating memory for grad\n");  
	tmem+=(mpar+1)*sizeof(double *);
	for (i=0; i<=mpar; i++) {
		if ((grad[i]=malloc((mpar+1)*sizeof(double)))==NULL) srverror("allocating memory for grad()");  
		tmem+=(mpar+1)*sizeof(double);
    } 
	//fprintf(stderr," *** INFO-- grad: memory used:%ld\n",tmem);

/*            compute transformed var/cov matrix using delta method
c      NEW VAR/COV MATRIX = GRADIANT * VARCOV * GRADIANT'
C
C                      COMPUTE GRADIANT = DERIVATIVE OF TRANSFORMED
C                                         PARMS W/ RESPECT TO 
C                                         UNTRANSFORMED PARAMETERS
*/
	for (i=1; i<=nest; i++) for (j=1; j<=i; j++) {
		jj=i*(i-1)/2+j; vcmat[i][j]=vcmat[j][i]=h[jj];
	}
	//printf("ppar:"); for (j=1; j<=ncols; j++) printf(" %8.5f",ppar[j]); printf("\ngrad:\n");
	for (i=1; i<=nrows; i++)  {
		for (j=1; j<=ncols; j++) { 
			parval=ppar[j]; ppar[j]+=EPS; 
			for (sm=0, k=1; k<=ncols; k++)  sm+=dm(i,k)*ppar[k];
			sm2=sm+dm(i,j)*(parval-ppar[j]);
			if (itran1==2) {sm=exp(sm)/(1.0+exp(sm)); sm2=exp(sm2)/(1.0+exp(sm2));}
			else if (itran1==1) { sm=sin(sm)/2+0.5; sm2=sin(sm2)/2+0.5;}
			grad[i][j]=(sm2-sm)/(parval-ppar[j]); //printf(" %8.5f",grad[i][j]);
			ppar[j]=parval;
		}
		//printf("\n");
	}
	//printf("grad*varcov:\n");
	if ((tmp=malloc((mpar+1)*sizeof(double *)))==NULL) srverror("allocating memory for tmp\n");  
	tmem+=(mpar+1)*sizeof(double *);
	for (i=0; i<=mpar; i++) {
		if ((tmp[i]=malloc((mpar+1)*sizeof(double)))==NULL) srverror("allocating memory for tmp()"); 
		tmem+=(mpar+1)*sizeof(double);
    } //fprintf(stderr," *** INFO-- tmp: memory used:%ld\n",tmem);
	for (i=1; i<=nrows; i++) {  //   MULTIPLY GRADIANT * VARCOV
		for (j=1; j<=ncols; j++) {
			for (sm=0, k=1; k<=ncols; k++) sm+=grad[i][k]*vcmat[k][j];
			tmp[i][j]=sm; //printf(" %8.5f",sm);
		}
		//printf("\n");
	}
	//printf("prd*grad':\n");
	for (i=1; i<=nrows; i++) { //   MULTIPLY PRODUCT * GRADIANT'
		for (j=1; j<=nrows; j++) {
			for (sm=0, k=1; k<=ncols; k++) sm+=tmp[i][k]*grad[j][k];
			vcmat[i][j]=sm; //printf(" %8.5f",sm);
		}
		//printf("\n");
	}
	if (detail) {
        fprintf(G,"\n\n                                                         95%% Confidence Interval\n");
        fprintf(G,"   I    Parameter              S(i)     Standard Error    Lower         Upper\n");
        fprintf(G,"  ---  -------------------- ------------ ------------ ------------ ------------\n");
        itrans=itran1;
		for (i=1; i<=nrows; i++) {
			separ=sqrt(vcmat[i][i]);
			for (sm=0, k=1; k<=ncols; k++) sm+=dm(i,k)*par[k];
			if (itrans==1) xphi=sin(sm)/2.+0.5;
			else xphi=exp(sm)/(1.0+exp(sm));
			lci=xphi-1.96*separ; uci=xphi+1.96*separ;
			fprintf(G,"%4d %-20s%12.6f %12.6f %12.6f %12.6f\n",i,slabel[i],xphi,separ,lci,uci);
		}
	//              PRINT VARIANCE-COVARIANCE MATRIX
		if (!novar) {
			fprintf(G,"\nVariance-Covariance matrix of estimates on diagonal and below,\n");
            fprintf(G,  "      Correlation matrix of estimates above diagonal.\n");
            for (i=1; i<=nrows; i++) 
                for (j=i+1; j<=nrows; j++) 
                    if (vcmat[i][i]>0 && vcmat[j][j]>0)
                        vcmat[j][i]=vcmat[i][j]/sqrt(vcmat[i][i]*vcmat[j][j]);
            for (i=1; i<=nrows; i++) {
                fprintf(G,"    |\n %3d|%12.5f",i,vcmat[1][i]);
                for (j=2; j<=nrows; j++) {
                    fprintf(G,"%12.5f",vcmat[j][i]);
                    if (j%6==0 || j==nrows) fprintf(G,"\n    |");
                }
            }
		}
	}
	for (i=0; i<=npar; i++) free(vcmat[i]); free(vcmat); tmem-=((npar+1)*sizeof(double *)+(npar+1)*(npar+1)*sizeof(double));
	for (i=0; i<=npar; i++) free(grad[i]); free(grad); tmem-=((npar+1)*sizeof(double *)+(npar+1)*(npar+1)*sizeof(double));
	for (i=0; i<=npar; i++) free(tmp[i]); free(tmp); tmem-=((npar+1)*sizeof(double *)+(npar+1)*(npar+1)*sizeof(double));
}
